﻿<?php
	header("Content-type: text/html; charset=UTF-8");
	mb_language("Japanese");
	mb_internal_encoding("UTF-8");
?>
<?php
FormEncode($_POST); //←これでPOSTデータ内が全てUTF-8化されます
 
/**
 * フォームから来たデータをエンコードする
 * @param array $post フォームから来たデータ
 */
function FormEncode(&$post){
    if ( !isset($post['txtCmd']) ){
        return;
    }
    //どのエンコーディングか判定
    $enc = mb_detect_encoding($post['txtCmd']);
    $default_enc = "UTF-8";
    foreach ($post as &$value) {
        EncodeCore($value,$default_enc,$enc);
    }
    unset($value);
}
/**
 * エンコードのコア部分
 * @param unknown_type $value
 * @param string $default_enc
 * @param string $enc
 */
function EncodeCore( &$value , $default_enc , $enc){
    if( is_array($value)){
        //配列の場合は再帰処理
        foreach ($value as &$value2) {
            EncodeCore($value2 , $default_enc , $enc);    
        }
    }else if( $enc != $default_enc){
        //文字コード変換
        $value = mb_convert_encoding( $value , $default_enc , $enc ) ;
    }
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta content="ja" http-equiv="Content-Language" />
<meta content="text/html; charset=UTF-8" http-equiv="Content-Type" />
<title>WebRemoteDOS</title>
<style type="text/css">
<!--
html,body{
  height: 90%;
}
-->
</style>

<?php
    session_start();
?>

<SCRIPT LANGUAGE="JavaScript">
<!--
function func(){ 
    var obj = document.body;
    if(!obj) return;
    obj.scrollTop = obj.scrollHeight;
    parent.footer.frmMain.txtCmd.focus();
    scrollTo(0, document.body.scrollHeight)
//window.alert("OK");
}
// -->
</SCRIPT>
</head>

<body bgcolor="#000000" text="#FFFFFF" onload="func();">

<?php
function chk_cmd($pstrCmd) {

    $pstrCmd = strtolower(trim($pstrCmd));
	if ( chk_cmd_sub($pstrCmd, "cd ") == true || chk_cmd_sub($pstrCmd, "chdir ") == true ) {
	    return 1;
	} elseif ( strpos($pstrCmd, ">") != null || strpos($pstrCmd, "|") != null ) {
	    return 0;
	} 

	$blnRtnFlg = true;
	if ( chk_cmd_sub($pstrCmd, "chkdsk") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "comp ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "diskcomp") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "diskcopy") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "driverquery") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "fc ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "find ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "findstr ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "openfiles") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "path") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "systeminfo") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "tasklist") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "tree") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "type ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "wmic") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "ipconfig") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "netstat") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "ping ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "tracert ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "dir") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "help") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "ver") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "whoami") == true ) {
	} else {
		$blnRtnFlg = false;
	}

	if ( $blnRtnFlg == true ) {
		return 0;
	}
	
	if ( chk_cmd_sub($pstrCmd, "date") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "del ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "erase ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "md ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "mkdir ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "move ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "rd ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "ren ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "rename ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "replace ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "rmdir ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "sc ") == true ) {
		return 0;
	} elseif ( chk_cmd_sub($pstrCmd, "taskkill ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "copy ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "xcopy ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "robocopy ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "md ") == true ) {
	} elseif ( chk_cmd_sub($pstrCmd, "shutdown ") == true ) {
		return 0;
	} elseif ( chk_cmd_sub($pstrCmd, "cmd") == true ) {
		return 3;
	}

	return 0;
	
}

function chk_cmd_sub($pstrCmd, $pstrChkCmd) {

    $blnRtnFlg = false;
    
 	if ( strcmp(substr($pstrCmd, 0, strlen($pstrChkCmd)), $pstrChkCmd) == 0 ) {
	    $blnRtnFlg = true;
	} 
	
	return $blnRtnFlg ;
}

	$strCmdDisplay = '';
	$strCmd = '';
	$strOutputText = '';
    if (!isset($_COOKIE["PHPSESSID"])){
		$strCmd = '';
		$strWorkDir = getcwd();
//		$strOutputFile = tempnam(getcwd(), "WRD");
		$strOutputFile = $strWorkDir.'\\'.get_current_user().'.tmp';
		$_SESSION["WorkDir"] = $strWorkDir;
		$_SESSION["OutputFile"] = $strOutputFile;
		//unlink($strOutputFile);
    }else{
		$strOutputFile = $_SESSION["OutputFile"];

		if ( !isset($_POST['txtCmd']) || $_POST['txtCmd'] == "" ) {
		} else {
			$strCmdDisplay = $_POST["txtCmd"];
			$strCmdTemp = trim($_POST["txtCmd"]);
			$strCmd     = '';
			$strCmdArg  = '';
			if (strpos($strCmdTemp, ' ') !== false) {
				$strCmd = substr($strCmdTemp, 0, strpos($strCmdTemp, ' '));
				$strCmdArg  = substr($strCmdTemp, strlen($strCmd)+1);
			} else {
				$strCmd = trim($_POST["txtCmd"]);
			}
//			$strCmd = escapeshellcmd($strCmd);
			if ($strCmdArg != '') {
//				$strCmdArg = escapeshellarg($strCmdArg);
				$strCmd = $strCmd.' '.$strCmdArg;
			}
		}
		$strWorkDir = $_SESSION["WorkDir"];
    }

	if (  file_exists($strOutputFile) == FALSE || ( isset($_POST['txtCmd']) && chk_cmd_sub(strtolower(trim($_POST['txtCmd'])), "cls") == true ) ) {
//	if ( !isset($_POST['txtCmd']) || $_POST['txtCmd'] == "" ) {
		exec('ver >'.$strOutputFile);

		$strOutputText = file_get_contents($strOutputFile);
		$strOutputText = str_replace("\r\n", '', $strOutputText);
		file_put_contents($strOutputFile, $strOutputText);

		exec('echo;>>'.$strOutputFile);
		exec('echo Copyright (c) Microsoft Corporation.  All rights reserved.>>'.$strOutputFile);
	} else {
		$strCmdDisplay = str_replace(">", '^>', $strCmdDisplay);

        //文字コード変換
		// HTMLとして出力する文字はUTF-8に変換する、printの場合も
	    // コマンド打つときはSJISに変換する、テンプファイルへ出力するものはSJISで。
		if ( mb_detect_encoding($strCmdDisplay) != "UTF-8" ) {
        	$strCmdDisplay = mb_convert_encoding( $strCmdDisplay, "UTF-8", "SJIS,EUC-JP,auto" ) ;  
		}
		exec('echo '.mb_convert_encoding( $strCmdDisplay, "SJIS", "UTF-8,EUC-JP,auto" ).' >>'.$strOutputFile);

		if ( mb_detect_encoding($strCmd) != "SJIS" ) {
	        $strCmd = mb_convert_encoding( $strCmd, "SJIS", "UTF-8,EUC-JP,auto" ) ;  
		}

		switch (chk_cmd($strCmd)) {
		  case 1:
			$_SESSION["WorkDir"] = $strWorkDir;
			exec('echo '.mb_convert_encoding('ベータバージョンではCD,CHDIRコマンドは使用できません', "SJIS", "UTF-8,EUC-JP,auto").'>>'.$strOutputFile);
		    break;
		  case 2:
			exec('echo '.mb_convert_encoding('ベータバージョンではサポートしていない記号が使われています', "SJIS", "UTF-8,EUC-JP,auto").'>>'.$strOutputFile);
		    break;
		  case 3:
			exec('echo '.mb_convert_encoding('ベータバージョンではサポートしていません', "SJIS", "UTF-8,EUC-JP,auto").'>>'.$strOutputFile);
		    break;
		  default:
			try {
				set_time_limit(0);

				$strExec = $strCmd;
				exec('cmd.exe /c '.'"'.$strExec.'"', $strOutput, $return_var);
				if ($strOutput == NULL && $return_var == 1) {
					exec('echo '.mb_convert_encoding( "内部コマンドまたは外部コマンド、", "SJIS", "UTF-8,EUC-JP,auto" ).' >>'.$strOutputFile);
					exec('echo '.mb_convert_encoding( "操作可能なプログラムまたはバッチ ファイルとして認識されていません。", "SJIS", "UTF-8,EUC-JP,auto" ).' >>'.$strOutputFile);
				}
				
			} catch (Exception $e) {
			    // タイムアウトエラーは取得できない
				echo "例外キャッチ：", $e->getMessage(), "\n";
			}

			$fp = fopen($strOutputFile, "a");
			foreach ($strOutput as $a){
		        //文字コード変換
				fputs($fp,$a."\r\n");
			}
			fclose($fp);

		}
	}

	exec('echo;>>'.$strOutputFile);
	exec('cd>>'.$strOutputFile);

	$strOutputText = file_get_contents($strOutputFile);
	$strOutputText = substr($strOutputText, 0, strlen($strOutputText)-2);   // 改行コードを取り除く
	$strOutputText = $strOutputText.">";
	file_put_contents($strOutputFile, $strOutputText);

	// HTMLに出力する文字はUTF-8に変換する
	$strOutputText = mb_convert_encoding($strOutputText, "UTF-8", "SJIS,EUC-JP,auto");

	$strOutputText = htmlentities($strOutputText); 
	$strOutputText = str_replace("\r\n", '<br/>', $strOutputText);
	$strOutputText = str_replace(" ", '&nbsp', $strOutputText);
?>
    
	<form action="header.php" method="post" name="frmMain" style="width: 100%;">
	  <input name="txtCmd" style="width: 95%" type="hidden" />
	</form>

	<div style="width:100%; height:100%;">
	<?php print $strOutputText ?>
	</div>

</body>

</html>
